
public class Lib_scodes {
    /**  
     * constants for platforms  names  
     */   
    public static String PL_M = "motorola";
    public static String PL_NO = "nokia";
    public static String PL_SE = "SE";
    public static String PL_SI = "siemens";
    public static String PL_SA = "samsung";
    public static String PL_LG = "LG";
    public static String PL_NA = "NA";

    public static String PLATFORM_NAME;

        /**  
     * standart values for softkeys of different platforms  
     * used only in predefining  
     */   
    private static int SK_L_SE = -6;
    private static int SK_R_SE = -7;
    //private static int DELETE_KEY_SE = -8;
    //private static int INTERNET_KEY_SE = -10;
    //private static int BACK_KEY_SE = -11;
    private static int SK_L_SA = -6;
    private static int SK_R_SA = -7;
    //private static int DELETE_KEY_SAMSUNG = -8;
    private static int SK_L_SI = -1;
    private static int SK_R_SI = -4;
    private static int SK_L_NO = -6;
    private static int SK_R_NO = -7;
    //private static int DELETE_KEY_NOKIA = -8;
    //private static int PENCIL_KEY_NOKIA = -50;
    private static int SK_L_M = -21;
    private static int SK_R_M = -22;
    private static int SK_L_M2 = -20;
    private static int SK_L_M1 = 21;
    private static int SK_R_M1 = 22;
    //private static int SOFT_KEY_MIDLE_MOTOROLA = -23;
    //private static int SOFT_KEY_MIDLE_NOKIA = -5;
  
    private static String SOFT_WORD = "SOFT";   

    public static String get_platform() {
        PLATFORM_NAME = detect_platform();
        return PLATFORM_NAME;
    }

    /**
     * Returns mobile phone platform  
     *  
     * @return name mobile phone platform  
     */   
    private static String detect_platform() {
        // detecting NOKIA or SonyEricsson   
        try {   
            final String currentPlatform = System.getProperty("microedition.platform");   
            if (currentPlatform.indexOf("Nokia") != -1) {   
                return PL_NO;
            } else if (currentPlatform.indexOf("SonyEricsson") != -1) {   
                return PL_SE;
            }   
        } catch (Throwable ex) {   
        }   
        // detecting SAMSUNG   
        try {   
            Class.forName("com.samsung.util.Vibration");   
            return PL_SA;
        } catch (Throwable ex) {   
        }   
        // detecting MOTOROLA   
        try {   
            Class.forName("com.motorola.multimedia.Vibrator");   
            return PL_M;
        } catch (Throwable ex) {   
            try {   
                Class.forName("com.motorola.graphics.j3d.Effect3D");   
                return PL_M;
            } catch (Throwable ex2) {   
                try {   
                    Class.forName("com.motorola.multimedia.Lighting");   
                    return PL_M;
                } catch (Throwable ex3) {   
                    try {   
                        Class.forName("com.motorola.multimedia.FunLight");   
                        return PL_M;
                    } catch (Throwable ex4) {   
                    }   
                }   
            }   
        }   
        try {   
            if (M.T.getKeyName(SK_L_M).toUpperCase().indexOf(SOFT_WORD) > -1) {
                return PL_M;
            }   
        } catch (Throwable e) {   
            try {   
                if (M.T.getKeyName(SK_L_M1).toUpperCase().indexOf(SOFT_WORD) > -1) {
                    return PL_M;
                }   
            } catch (Throwable e1) {   
                try {   
                    if (M.T.getKeyName(SK_L_M2).toUpperCase().indexOf(SOFT_WORD) > -1) {
                        return PL_M;
                    }   
                } catch (Throwable e2) {   
                }   
            }   
        }   
        // detecting SIEMENS   
        try {   
            Class.forName("com.siemens.mp.io.File");   
            return PL_SI;
        } catch (Throwable ex) {   
        }   
        // detecting LG   
        try {   
            Class.forName("mmpp.media.MediaPlayer");   
            return PL_LG;
        } catch (Throwable ex) {   
            try {   
                Class.forName("mmpp.phone.Phone");   
                return PL_LG;   
            } catch (Throwable ex1) {   
                try {   
                    Class.forName("mmpp.lang.MathFP");   
                    return PL_LG;   
                } catch (Throwable ex2) {   
                    try {   
                        Class.forName("mmpp.media.BackLight");   
                        return PL_LG;   
                    } catch (Throwable ex3) {   
                    }   
                }   
            }   
        }   
        return PL_NA;
    }
/**
     * define real left soft key code by platform
     *
     * @return code
     */
    public static int get_leftsoftkeycode() {
        int keyCode = 0;
        try {
            if (PLATFORM_NAME.equals(PL_M)) {
                String softkeyLeftMoto = "";
                try {
                    softkeyLeftMoto = M.T.getKeyName(SK_L_M).toUpperCase();
                } catch (IllegalArgumentException ilae) {
//                    ilae.printStackTrace();
                }
                String softkeyLeftMoto1 = "";
                try {
                    softkeyLeftMoto1 = M.T.getKeyName(SK_L_M1).toUpperCase();
                } catch (IllegalArgumentException ilae) {
//                    ilae.printStackTrace();
                }
                String softkeyLeftMoto2 = "";
                try {
                    softkeyLeftMoto2 = M.T.getKeyName(SK_L_M2).toUpperCase();
                } catch (IllegalArgumentException ilae) {
//                    ilae.printStackTrace();
                }
                if (softkeyLeftMoto.indexOf(SOFT_WORD) >= 0 && softkeyLeftMoto.indexOf("1") >= 0) {
                    return SK_L_M;
                } else if (softkeyLeftMoto1.indexOf(SOFT_WORD) >= 0 && softkeyLeftMoto1.indexOf("1") >= 0) {
                    return SK_L_M1;
                } else if (softkeyLeftMoto2.indexOf(SOFT_WORD) >= 0 && softkeyLeftMoto2.indexOf("1") >= 0) {
                    return SK_L_M2;
                } else if (softkeyLeftMoto.indexOf(SOFT_WORD) >= 0 && softkeyLeftMoto.indexOf("LEFT") >= 0) {
                    return SK_L_M;
                } else if (softkeyLeftMoto1.indexOf(SOFT_WORD) >= 0 && softkeyLeftMoto1.indexOf("LEFT") >= 0) {
                    return SK_L_M1;
                } else if (softkeyLeftMoto2.indexOf(SOFT_WORD) >= 0 && softkeyLeftMoto2.indexOf("LEFT") >= 0) {
                    return SK_L_M2;
                }

            } else if (PLATFORM_NAME.equals(PL_NO)) {
                return SK_L_NO;
            } else if (PLATFORM_NAME.equals(PL_SA)) {
//                String leftkeySamsungName = adaptorCanvas.getKeyName(SK_L_SA).toUpperCase();
//                if (leftkeySamsungName.indexOf(SOFT_WORD) >= 0) {
//                    if (leftkeySamsungName.indexOf("1") >= 0) {
                return SK_L_SA;
//                    } else if (leftkeySamsungName.indexOf("LEFT") >= 0) {
//                        return SK_L_SA;
//                    }
//                }
            } else if (PLATFORM_NAME.equals(PL_SI)) {
                String leftKeySiemensName = M.T.getKeyName(SK_L_SI).toUpperCase();
                if (leftKeySiemensName.indexOf(SOFT_WORD) >= 0) {
                    if (leftKeySiemensName.indexOf("1") >= 0) {
                        return SK_L_SI;
                    } else if (leftKeySiemensName.indexOf("LEFT") >= 0) {
                        return SK_L_SI;
                    }
                }
            } else if (PLATFORM_NAME.equals(PL_SE)) {
                return SK_L_SE;
            } else if (PLATFORM_NAME.equals(PL_NA)) {
                //
                for (int i = -125; i <= 125; i++) {
                    if (i == 0) {
                        i++;
                    }
//                    System.out.println(getKeyName(i).toUpperCase());
                    final String s = M.T.getKeyName(i).toUpperCase();
                    if (s.indexOf(SOFT_WORD) >= 0) {
                        if (s.indexOf("1") >= 0) {
                            keyCode = i;
                            break;
                        }
                        if (s.indexOf("LEFT") >= 0) {
                            keyCode = i;
                            break;
                        }
                    }
                }
            }
            if (keyCode == 0) {
                 return SK_L_NO;
            }
        } catch (Throwable iaEx) {
            return SK_L_NO;
        }
        return keyCode;
    }
    /**  
     * define real right soft key code for current platform  
     *  
     * @return code  
     */   
    public static int get_rightsoftkeycode() {   
        int keyCode = 0;   
        try {   
            if (PLATFORM_NAME.equals(PL_M)) {
  
                String rightSoftMoto1 = "";   
                try {   
                    rightSoftMoto1 = M.T.getKeyName(SK_L_M1).toUpperCase();
                } catch (IllegalArgumentException ilae) {   
//                    ilae.printStackTrace();   
                }   
                String rightSoftMoto = "";   
                try {   
                    rightSoftMoto = M.T.getKeyName(SK_R_M).toUpperCase();
                } catch (IllegalArgumentException ilae) {   
//                    ilae.printStackTrace();   
                }   
                String rightSoftMoto2 = "";   
                try {   
                    rightSoftMoto2 = M.T.getKeyName(SK_R_M1).toUpperCase();
                } catch (IllegalArgumentException ilae) {   
//                    ilae.printStackTrace();   
                }   
                if (rightSoftMoto.indexOf(SOFT_WORD) >= 0 && rightSoftMoto.indexOf("2") >= 0) {   
                    return SK_R_M;
                } else if (rightSoftMoto1.indexOf(SOFT_WORD) >= 0 && rightSoftMoto1.indexOf("2") >= 0) {   
                    return SK_R_M;
                } else if (rightSoftMoto2.indexOf(SOFT_WORD) >= 0 && rightSoftMoto2.indexOf("2") >= 0) {   
                    return SK_R_M1;
                } else if (rightSoftMoto.indexOf(SOFT_WORD) >= 0 && rightSoftMoto.indexOf("RIGHT") >= 0) {   
                    return SK_L_M;
                } else if (rightSoftMoto1.indexOf(SOFT_WORD) >= 0 && rightSoftMoto1.indexOf("RIGHT") >= 0) {   
                    return SK_R_M1;
                } else if (rightSoftMoto2.indexOf(SOFT_WORD) >= 0 && rightSoftMoto2.indexOf("RIGHT") >= 0) {   
                    return SK_R_M;
                }   
  
            } else if (PLATFORM_NAME.equals(PL_NO)) {
                return SK_R_NO;
            } else if (PLATFORM_NAME.equals(PL_SA)) {
//                String rightSoftSamsung = adaptorCanvas.getKeyName(SK_R_SA).toUpperCase();
//                if (rightSoftSamsung.indexOf(SOFT_WORD) >= 0) {   
//                    if (rightSoftSamsung.indexOf("2") >= 0) {   
                return SK_R_SA;
//                    } else if (rightSoftSamsung.indexOf("RIGHT") >= 0) {   
//                        return SK_R_SA;
//                    }   
//                }   
            } else if (PLATFORM_NAME.equals(PL_SI)) {
                String rightSoftSiemens = M.T.getKeyName(SK_R_SI).toUpperCase();
                if (rightSoftSiemens.indexOf(SOFT_WORD) >= 0) {   
                    if (rightSoftSiemens.indexOf("4") >= 0) {   
                        return SK_R_SI;
                    } else if (rightSoftSiemens.indexOf("RIGHT") >= 0) {   
                        return SK_R_SI;
                    }   
                }   
            } else if (PLATFORM_NAME.equals(PL_SE)) {
                return SK_R_SE;
            } else if (PLATFORM_NAME.equals(PL_NA)) {
                for (int i = -125; i <= 125; i++) {   
                    if (i == 0) {   
                        i++;   
                    }   
                    String keyName = M.T.getKeyName(i).toUpperCase();   
                    if (keyName.indexOf(SOFT_WORD) >= 0) {   
                        if (keyName.indexOf("2") >= 0) {   
                            keyCode = i;   
                            break;   
                        } else if (keyName.indexOf("4") >= 0) {   
                            keyCode = i;   
                            break;   
                        } else if (keyName.indexOf("RIGHT") >= 0) {   
                            keyCode = i;   
                            break;   
                        }   
                    }   
                }   
            }   
            if (keyCode == 0) {
                 return SK_R_NO;
            }
        } catch (Throwable iaEx) {   
            return SK_R_NO;
        }   
        return keyCode;   
    }
}

